# Visualization
TKV3d
AIS

# AIS_TangentRelation Class Reference

A framework to display tangency constraints between
two or more Interactive Objects of the datum type.
The datums are normally faces or edges.
.

`#include <AIS_TangentRelation.hxx>`

Inheritance diagram for AIS_TangentRelation:

[legend]

## Public Member Functions

Standard_EXPORT | AIS_TangentRelation (const TopoDS_Shape &aFShape, const TopoDS_Shape &aSShape, const Handle(Geom_Plane)&aPlane, const Standard_Integer anExternRef=0)
| TwoFacesTangent or TwoEdgesTangent relation //! Constructs an object to display tangency constraints. This object is defined by the first shape aFShape, the second shape aSShape, the plane aPlane and the index anExternRef. aPlane serves as an optional axis. anExternRef set to 0 indicates that there is no relation. .
Standard_EXPORT Standard_Integer | ExternRef ()
| Returns the external reference for tangency. The values are as follows: - 0 - there is no connection; - 1 - there is a connection to the first shape; - 2 - there is a connection to the second shape. This reference is defined at construction time. .
Standard_EXPORT void | SetExternRef (const Standard_Integer aRef)
| Sets the external reference for tangency, aRef. The values are as follows: - 0 - there is no connection; - 1 - there is a connection to the first shape; - 2 - there is a connection to the second shape. This reference is initially defined at construction time. .
virtual Standard_EXPORT void | Compute (const Handle(Prs3d_Projector)&aProjector, const Handle(Geom_Transformation)&aTrsf, const Handle(Prs3d_Presentation)&aPresentation)
| computes the presentation according to a point of view given by <aprojector>. To be Used when the associated degenerated Presentations have been transformed by <atrsf> which is not a Pure Translation. The HLR Prs can't be deducted automatically WARNING :<atrsf> must be applied to the object to display before computation !!!
Standard_EXPORT const | Handle (Standard_Type)&DynamicType() const

## Private Member Functions

Standard_EXPORT void | Compute (const Handle(PrsMgr_PresentationManager3d)&aPresentationManager, const Handle(Prs3d_Presentation)&aPresentation, const Standard_Integer aMode=0)
| Calculates the 3D view aPresentation and its updates. The latter are managed by aPresentationManager. aPresentableObject has the display mode aMode; this has the default value of 0, that is, the wireframe display mode. .
Standard_EXPORT void | Compute (const Handle(Prs3d_Projector)&aProjector, const Handle(Prs3d_Presentation)&aPresentation)

Calculates the 3D view aPresentation and its
updates. The latter are managed by
aPresentationManager. Each of the views in the
viewer and every modification such as rotation, for
example, entails recalculation.
It must be redefined to implement hidden line removal
for the object. The user never calls this method
himself. This is done via the InteractiveContext object
and is dependent on the point of view from which the
object is displayed.
.

Standard_EXPORT void | Compute (const Handle(PrsMgr_PresentationManager2d)&aPresentationManager, const Handle(Graphic2d_GraphicObject)&aPresentation, const Standard_Integer aMode=0)
| Calculates the 2D view aPresentation and its updates. The latter are managed by aPresentationManager. aPresentableObject has the display mode aMode; this has the default value of 0, that is, the wireframe display mode. Note that this syntax is not used in AIS as that package only concerns 3D display. .
Standard_EXPORT void | ComputeSelection (const Handle(SelectMgr_Selection)&aSelection, const Standard_Integer aMode)

Recovers and calculates any sensitive primitive,
aSelection, available in Shape mode, specified by
aMode. As a rule, these are sensitive faces.
This method is defined as virtual. This enables you to
implement it in the creation of a new class of AIS
Interactive Object. You need to do this and in so
doing, redefine this method, if you create a class
which enriches the list of signatures and types.
.

Standard_EXPORT void | ComputeTwoFacesTangent (const Handle(Prs3d_Presentation)&aPresentation)
Standard_EXPORT void | ComputeTwoEdgesTangent (const Handle(Prs3d_Presentation)&aPresentation)

## Private Attributes

gp_Pnt | myAttach
gp_Dir | myDir
Standard_Real | myLength
Standard_Integer | myExternRef

## Constructor & Destructor Documentation

Standard_EXPORT AIS_TangentRelation::AIS_TangentRelation | ( | const TopoDS_Shape & | aFShape,
|  | const TopoDS_Shape & | aSShape,
|  | const Handle(Geom_Plane)& | aPlane,
|  | const Standard_Integer | anExternRef = `0`
| ) |

## Member Function Documentation

Standard_EXPORT void AIS_TangentRelation::Compute | ( | const Handle(PrsMgr_PresentationManager2d)& | aPresentationManager,
|  | const Handle(Graphic2d_GraphicObject)& | aPresentation,
|  | const Standard_Integer | aMode = `0`
| ) | `[private, virtual]`

| Reimplemented from PrsMgr_PresentableObject.

Standard_EXPORT void AIS_TangentRelation::Compute | ( | const Handle(Prs3d_Projector)& | aProjector,
|  | const Handle(Prs3d_Presentation)& | aPresentation
| ) | `[private, virtual]`

| Reimplemented from PrsMgr_PresentableObject.

Standard_EXPORT void AIS_TangentRelation::Compute | ( | const Handle(PrsMgr_PresentationManager3d)& | aPresentationManager,
|  | const Handle(Prs3d_Presentation)& | aPresentation,
|  | const Standard_Integer | aMode = `0`
| ) | `[private, virtual]`

| Reimplemented from PrsMgr_PresentableObject.

virtual Standard_EXPORT void AIS_TangentRelation::Compute | ( | const Handle(Prs3d_Projector)& | aProjector,
|  | const Handle(Geom_Transformation)& | aTrsf,
|  | const Handle(Prs3d_Presentation)& | aPresentation
| ) | `[virtual]`

| Reimplemented from PrsMgr_PresentableObject.

Standard_EXPORT void AIS_TangentRelation::ComputeSelection | ( | const Handle(SelectMgr_Selection)& | aSelection,
|  | const Standard_Integer | aMode
| ) | `[private, virtual]`

| Implements SelectMgr_SelectableObject.

Standard_EXPORT void AIS_TangentRelation::ComputeTwoEdgesTangent | ( | const Handle(Prs3d_Presentation)& | aPresentation | ) | `[private]`

Standard_EXPORT void AIS_TangentRelation::ComputeTwoFacesTangent | ( | const Handle(Prs3d_Presentation)& | aPresentation | ) | `[private]`

Standard_EXPORT Standard_Integer AIS_TangentRelation::ExternRef | ( |  | ) |

Standard_EXPORT const AIS_TangentRelation::Handle | ( | Standard_Type |  | ) | const

| Reimplemented from AIS_Relation.

Standard_EXPORT void AIS_TangentRelation::SetExternRef | ( | const Standard_Integer | aRef | ) |

## Field Documentation

gp_Pnt AIS_TangentRelation::myAttach `[private]`

gp_Dir AIS_TangentRelation::myDir `[private]`

Standard_Integer AIS_TangentRelation::myExternRef `[private]`

Standard_Real AIS_TangentRelation::myLength `[private]`

The documentation for this class was generated from the following file:

- AIS_TangentRelation.hxx